// require('expose-loader?$!jquery')
$(document).ready(function () {
  function getUrlParam (name) {
    var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)')
    var r = window.location.search.substr(1).match(reg)
    if (r != null) return unescape(r[2]); return null
  }
  var number = getUrlParam('number')
  var updateId = getUrlParam('updateId')
  var processCode = getUrlParam('processCode') || ''
  var centerId = getUrlParam('centerId')
  var taskid = getUrlParam('taskid')
  var appNumber = getUrlParam('appNumber')
  // var index = getUrlParam('index')
  function postApi (url, data = {}) {
    return $.ajax({
      type: 'post',
      url: url,
      async: true,
      dataType: 'json',
      data: JSON.stringify(data),
      contentType: 'application/json;charset=UTF-8',
      beforeSend: function () {
        $('.mask').show();
      },
      complete: function () {
        $('.mask').hide();
      },
      success: function (res) {
        return res
      },
      error: function (res) {
        console.log(res)
      }
    })
  }
  // 获取单步日志
  function getEnvUpdateLogService (updateId, processCode) {
    let data = {
      updateId: updateId,
      processCode: processCode
    }
    let url = 'kapi/app/mc/getEnvUpdateLogService'
    return postApi(url, data)
  }
  // 获取数据中心单个包日志
  function getUpgradeStateService (taskid) {
    let data = {
      taskid: taskid
    }
    let url = 'kapi/app/mc/getUpgradestateService'
    return postApi(url, data)
  }
  // 获取元数据重建单个包日志
  function getRebuildDataResultService (updateId, centerId, appNumber) {
    let data = {
      updateId: updateId,
      datacenterId: centerId,
      appNumber: appNumber
    }
    let url = 'kapi/app/mc/getRebuildDataResultService'
    return postApi(url, data)
  }
  function replaceAll (str) {
    str = str.replace(new RegExp(/(\n\t)/g), '<br>')
    return str
  }
  let logs = ''
  let scrollToTop = Number(window.sessionStorage.getItem('top'))
  if (taskid) { // 获取数据中心升级单个日志
    getUpgradeStateService(taskid).then(resp => {
      // if (resp.errorcode == 100) {
        let respLog = resp.data && resp.data.logs
        let dom = document.getElementById('upLog')
        logs += '<div style="font-size:14px;font-weight:normal;">'
        logs += respLog
        logs += '</div>'
        dom.innerHTML = logs
        var scrollHeight = $(dom).prop("scrollHeight");
        $(dom).scrollTop(scrollHeight, 200);
        // setTimeout(() => {
        //   dom.scrollTop = scrollToTop || 0
        // }, 0)
      // }
    })
  } else if (appNumber) { // 获取元数据重建单个日志
    getRebuildDataResultService(updateId, centerId, appNumber).then(resp => {
      if (resp.errorcode == 100) {
        let respLog = resp.data && resp.data[0] && resp.data[0].detail && resp.data[0].detail[0] && resp.data[0].detail[0].msg
        respLog = respLog.join('<br/>')
        logs += '<div style="font-size:14px;font-weight:normal;">'
        logs += respLog
        logs += '</div>'
        let dom = document.getElementById('upLog')
        dom.innerHTML = logs
        setTimeout(() => {
          dom.scrollTop = scrollToTop || 0
        }, 0)
      }
    })
  } else if (processCode === 'rebuildMetaData') { // 获取元数据重建所有日志
    getRebuildDataResultService(updateId, centerId).then(resp => {
      if (resp.errorcode == 100) {
        let respLog = resp.data && resp.data[0] && resp.data[0].log
        // respLog = respLog.join('<br/>')
        logs += '<div style="font-size:14px;font-weight:normal;">'
        logs += respLog
        logs += '</div>'
        let dom = document.getElementById('upLog')
        dom.innerHTML = logs
        setTimeout(() => {
          dom.scrollTop = scrollToTop || 0
        }, 0)
      }
    })
  } else { // 获取其他单步日志（包括数据中心升级所有日志）
    getEnvUpdateLogService(updateId, processCode).then(resp => {
      if (resp.errorcode == 100) {
        let respLog = resp.data && resp.data.join('<br/>')
        logs += '<div style="font-size:14px;font-weight:normal;">'
        logs += respLog
        logs += '</div>'
        let dom = document.getElementById('upLog')
        dom.innerHTML = logs
        setTimeout(() => {
          dom.scrollTop = scrollToTop || 0
        }, 0)
      }
    })
  }
  function setScrollY (e) {
    let top = dom.scrollTop || 0
    window.sessionStorage.setItem('top', top)
  }
  let dom = document.getElementById('upLog')
  dom.addEventListener('scroll', setScrollY)
})
// $(window).load(function () {
//   let dom = document.getElementById('upLog')
//   let scrollToTop = window.sessionStorage.getItem('top')
//   if (scrollToTop) {
//     dom.scrollTop = Number(scrollToTop)
//   }
// })
// $(window).unload(function () {
//   let dom = document.getElementById('upLog')
//   let top = dom.scrollTop || 0
//   window.sessionStorage.setItem('top', top)
// })
